
<!DOCTYPE html>
<html>
  <head>
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>React Drum Band</title>
    <!-- ICONS-->
     <link rel="stylesheet" href="https://use.fontawesome.com/releases/v5.8.1/css/all.css" integrity="sha384-50oBUHEmvpQ+1lW4y57PTFmhCaXp0ML5d60M1M7uH2+nqUivzIebhndOJK28anvf" crossorigin="anonymous">
     <link rel="stylesheet" href="style.css">
     <!--REACT -->
    <script crossorigin src="https://unpkg.com/react@16/umd/react.production.min.js"></script>
    <!-- REACT DOM-->
<script crossorigin src="https://unpkg.com/react-dom@16/umd/react-dom.production.min.js"></script>
  </head>
  <body>
        <a href="https://linkedin.com/in/fsbalbuena/">FSBalbuena</a>  
    <main id="main"></main>
    <script src="https://unpkg.com/babel-standalone@6/babel.min.js"></script>
    <script type="text/babel">
    //---------------------------------------------------
//----------------COMPONENTS-----------------------------------
const Display=({text})=>(<p id="display">{text}</p>)
const Drumpad=({text,audioText,audio,handleClick})=>(<button onClick={handleClick} id={audioText} className="drum-pad">{text}
<audio id={text} src={audio} className="clip"/></button>)
//---------------------------------------------------
//----------------CONTEINERS-----------------------------------
class DrumMachineContainer extends React.Component{
    constructor(props){
        super(props)
        this.state={
            text:"Drum me!"
        }
        this.handleText=this.handleText.bind(this)
    }
    handleText(text){
        this.setState({text:text})
    }
    render(){
        const{text}=this.state
        return(
        <div id="drum-machine">
            <DrumpadsContainer handleText={this.handleText}/>
             <Display text={text}/>
        </div>)
    }
}

class DrumpadsContainer extends React.Component{
    constructor(props){
        super(props)
        this.state={
            drumpads:[
                {char:"Q",audio:"https://s3.amazonaws.com/freecodecamp/drums/Heater-1.mp3",charCode:81,audioText:"Heater-1.mp3"
                },{char:"W",audio:"https://s3.amazonaws.com/freecodecamp/drums/Heater-2.mp3",charCode:87,audioText:"Heater-2.mp3"
                },{char:"E",audio:"https://s3.amazonaws.com/freecodecamp/drums/Heater-3.mp3",charCode:69,audioText:"Heater-3.mp3"
                },{char:"A",audio:"https://s3.amazonaws.com/freecodecamp/drums/Heater-4_1.mp3",charCode:65,audioText:"Heater-4_1.mp3"
                },{char:"S",audio:"https://s3.amazonaws.com/freecodecamp/drums/Heater-6.mp3",charCode:83,audioText:"Heater-6.mp3"
                },{char:"D",audio:"https://s3.amazonaws.com/freecodecamp/drums/Dsc_Oh.mp3",charCode:68,audioText:"Dsc_Oh.mp3"
                },{char:"Z",audio:"https://s3.amazonaws.com/freecodecamp/drums/Kick_n_Hat.mp3",charCode:90,audioText:"Kick_n_Hat.mp3"
                },{char:"X",audio:"https://s3.amazonaws.com/freecodecamp/drums/RP4_KICK_1.mp3",charCode:88,audioText:"RP4_KICK_1.mp3"
                },{char:"C",audio:"https://s3.amazonaws.com/freecodecamp/drums/Cev_H2.mp3",charCode:67,audioText:"Cev_H2.mp3"
                }   
            ]
        }
        this.handleClick=this.handleClick.bind(this)
    }
    componentDidMount(){
      let drumpads=this.state.drumpads
      let handleClick=this.handleClick
        document.onkeydown=function(e){
            let key=e.keyCode
            let drum=drumpads.filter(d=>d.charCode==key)
            drum=drum.length==1?drum[0]:null
            drum && handleClick(drum.char,drum.audioText)
        }
    }
    handleClick(audioId,buttonId){
       document.getElementById(audioId).play()
        this.props.handleText(buttonId.replace(/-/g," "))
    }
    render(){
        const {drumpads}=this.state
        const {handleClick}=this
        return(
        <div id="drumpadContainer">
                {drumpads.map((d)=>(<Drumpad text={d.char} audioText={d.audioText} audio={d.audio} handleClick={()=>handleClick(d.char,d.audioText)}/>))}
        </div>)
    }
}


//----------------------------------------------------
//---------------------------------------------------
const Main=()=>(<div className="main">
    <h1>Drum It Baby</h1><DrumMachineContainer/></div>)

ReactDOM.render(<Main/>,document.getElementById("main"))

    </script>
  </body>
</html>